/*
Doopfinder: A duplicate file finder
Copyright  2011 Ben Shultz pipesc@comcast.com

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include <windows.h>
#include <iostream>
#include "stdio.h"
using namespace std;

struct thedir{char *infodir;};

struct FILE_DIR
{
	unsigned int files;
	unsigned int dir;
};

//crc code STOLEN and modifided from http://www.createwindow.com/programming/crc32/
//this will maybe later get replaced, till then $2 donations go to this guy for every $5 I get in donations
ULONG crc32_table[256];

ULONG Reflect(ULONG ref, char ch)
{// Used only by Init_CRC32_Table()

     ULONG value(0);

     // Swap bit 0 for bit 7
     // bit 1 for bit 6, etc.
     for(int i = 1; i < (ch + 1); i++)
     {
          if(ref & 1)
               value |= 1 << (ch - i);
          ref >>= 1;
     }
     return value;
}

void Init_CRC32_Table()
{// Called by OnInitDialog()

     // This is the official polynomial used by CRC-32
     // in PKZip, WinZip and Ethernet.
     ULONG ulPolynomial = 0x04c11db7;

     // 256 values representing ASCII character codes.
     for(int i = 0; i <= 0xFF; i++)
     {
          crc32_table[i]=Reflect(i, 8) << 24;
          for (int j = 0; j < 8; j++)
               crc32_table[i] = (crc32_table[i] << 1) ^ (crc32_table[i] & (1 << 31) ? ulPolynomial : 0);
          crc32_table[i] = Reflect(crc32_table[i], 32);
     }
}

int Get_CRC(char *csfilename, DWORD dwSize)
{
     // Be sure to use unsigned variables,
     // because negative values introduce high bits
     // where zero bits are required.
     ULONG crc(0xffffffff);

     int len;

     len = dwSize;
     // Save the text in the buffer.
	 FILE *thefile;
	 thefile=fopen(csfilename,"rb");

     // Perform the algorithm on each character
     // in the string, using the lookup table values.

     while(len--)
	 {
		  unsigned char data;
		  if(thefile) fread(&data,1,1,thefile);
		  else return 1;
          crc = (crc >> 8) ^ crc32_table[(crc & 0xFF) ^ data];
	 }
     // Exclusive OR the result with the beginning value.
	 if(thefile) fclose(thefile);

     return crc^0xffffffff;
}

FILE_DIR countfiles(char *listpath)
{
	WIN32_FIND_DATA info;
	HANDLE hFile;
	hFile=FindFirstFile(listpath, &info);
	FILE_DIR filedir;
	filedir.dir=0;
	filedir.files=0;
	DWORD atr=info.dwFileAttributes;

	if(hFile!=INVALID_HANDLE_VALUE)
	{
		for(;;)
		{
			if((atr&FILE_ATTRIBUTE_SYSTEM)!=FILE_ATTRIBUTE_SYSTEM) filedir.dir++;

			if(!FindNextFile(hFile, &info))
			{
				FindClose(hFile);
				break;
			}
		}
	}
	return filedir;
}

class searchfiles
{

public:
	
	searchfiles()
	{
		

	}

	~searchfiles()
	{

	}

	int listthem(char *dirname, char *list_name)
	{
		int the_return=0;

		FILE *txtlist;
		txtlist=fopen(list_name,"a+");
		if(!txtlist) return 1;

		char listpath[MAX_PATH]="";
		strncat(listpath, dirname, strlen(dirname));
		strncat(listpath, "*.*", 3);

		FILE_DIR filedir;
		filedir=countfiles(listpath);

		WIN32_FIND_DATA info;

		thedir *dirlist=new thedir[filedir.dir];

		HANDLE hFile;
		unsigned int countdir=0;

		searchfiles indir;

		if(listpath)
		{

			hFile=FindFirstFile(listpath, &info);

			if(hFile!=INVALID_HANDLE_VALUE)
			{
				cout << "xxxxxxxx|xxxxxxxx|" << dirname << "\n";
				fwrite("xxxxxxxx|xxxxxxxx|",1,18,txtlist);
				fwrite(dirname,1,strlen(dirname),txtlist);
				fwrite("\n",1,1,txtlist);

				for(;;)
				{
					char filepath_name[MAX_PATH];

					strcpy(filepath_name,dirname);
					strcat(filepath_name,info.cFileName);
					DWORD atr=info.dwFileAttributes;

					if((atr&FILE_ATTRIBUTE_SYSTEM)!=FILE_ATTRIBUTE_SYSTEM)
					{
						if((atr&FILE_ATTRIBUTE_DIRECTORY)!=FILE_ATTRIBUTE_DIRECTORY)
						{
							unsigned long crc=Get_CRC(filepath_name, info.nFileSizeLow);

							char crc_number[8];
							if(crc!=1)
							{
								sprintf(crc_number,"%8x|%8x|",crc,info.nFileSizeLow);

								cout << crc_number << dirname << info.cFileName << "\n";
								fwrite(crc_number,1,18,txtlist);
							}
							else
							{
								cout << "--------|--------|" << dirname << info.cFileName << "\n";
								fwrite("--------|--------|",1,18,txtlist);
							}

							fwrite(dirname,1,strlen(dirname),txtlist);
							fwrite(info.cFileName,1,strlen(info.cFileName),txtlist);
							fwrite("\n",1,1,txtlist);
						}
						else
						{
							if((info.cFileName[0]!='.'&&info.cFileName[1]!=0)||(info.cFileName[0]!='.'&&info.cFileName[1]!='.'&&info.cFileName[2]!=0))
							{
								unsigned int charcount=0;
								dirlist[countdir].infodir=new char[MAX_PATH];
								do
								{
									dirlist[countdir].infodir[charcount]=info.cFileName[charcount];
								}while(info.cFileName[charcount++]);
								countdir++;
							}
						}
					}

					if(!FindNextFile(hFile, &info))
					{
					
						searchfiles indir;

						for(unsigned int cdir=0; cdir<countdir; cdir++)
						{
							char dirpath[MAX_PATH]="";
							strncat(dirpath, dirname, MAX_PATH);
							char *tester=strncat(dirpath,dirlist[cdir].infodir,MAX_PATH);
							strncat(dirpath,"\\",1);

							if(txtlist) fclose(txtlist);
							indir.listthem(dirpath, list_name);
							delete [] dirlist[cdir].infodir;
						}

						delete [] dirlist;

						if(hFile) FindClose(hFile);
						break;
					}

				}
			}
			else
			{
				the_return=1;
				delete [] dirlist;
			}
		}
		
		
		if(txtlist) fclose(txtlist);

		return the_return;

	}


};
/*
creating a "found doop" dir if it isn't there
*/
int main(int argc, char *argv[])
{

	//check for valid strings
	if(argc==2&&argv[1][1]=='w')
	{
		cout << "15. Disclaimer of Warranty.\nTHERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY\nAPPLICABLE LAW.  EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT\nHOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM \"AS IS\" WITHOUT WARRANTY\nOF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO,\nTHE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR\nPURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM\nIS WITH YOU.  SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF\nALL NECESSARY SERVICING, REPAIR OR CORRECTION.\n\n";

		cout << "This program is free software: you can redistribute it and/or modify\nit under the terms of the GNU General Public License as published by\nthe Free Software Foundation, either version 3 of the License, or\n(at your option) any later version.\nThis program is distributed in the hope that it will be useful,\nbut WITHOUT ANY WARRANTY; without even the implied warranty of\nMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\nGNU General Public License for more details.\nYou should have received a copy of the GNU General Public License\nalong with this program.  If not, see <http://www.gnu.org/licenses/>.\n\n";
		return 0;
	}

	bool isvalid=false;
	int i=3;
	if(argc>3)
	{
		while(!isvalid&&argc!=i)
		{
			if(argv[i][0]=='-') isvalid=true;
			i++;
		}
		if(i==argc) isvalid=false;
	}

	if(isvalid)
	{
		char working_dir[MAX_PATH];
		char working_list[MAX_PATH];

		strcpy(working_list, argv[2]);
		strcat(working_list, " ");
		int i=3;

		while(argv[i][0]!='-')//read argv for text file till dir is reached
		{
			strcat(working_list, argv[i]);
			strcat(working_list, " ");
			i++;
		}
		
		i++;

		strcpy(working_dir, argv[i]);//read the dir location
		strcat(working_dir, " ");
		i++;

		while(argv[i])
		{
			strcat(working_dir, argv[i]);
			strcat(working_dir, " ");
			i++;
		}

		int size_str=0;

		//remove last space on the working strings and add a backslash to the dir string

		//get size of string till 0 is found
		while(working_list[size_str]!='\0') size_str++;
		working_list[size_str-1]='\0';

		//size_str is reset for dir string
		size_str=0;
		//get size of string till 0 is found
		while(working_dir[size_str]!='\0') size_str++;
		if(working_dir[size_str-2]=='\\')
		{
			working_dir[size_str-1]='\0';
		}
		else
		{
			working_dir[size_str-1]='\\';
			working_dir[size_str]='\0';
		}
		
		//in the mood to do the ifs then a switch
		if(argv[1][1]=='l')
		{
			Init_CRC32_Table();
				
			searchfiles search;

			if(search.listthem(working_dir, working_list))
			{
				cout << "Not a valid directory or file!\n";
				return 5;
			}else
			{

				return 0;
			}
		}
		else if(argv[1][1]=='f')
		{
			//searching files here
			FILE *list_file;
			list_file=fopen(working_list,"r");
			if(!list_file)
			{
				cout << "Not a valid file!\n";
				return 5;
			}

			WIN32_FIND_DATA info;
			HANDLE hFile;
			hFile=FindFirstFile(working_dir, &info);

			if(hFile==INVALID_HANDLE_VALUE)
			{
				if(!CreateDirectory(working_dir,NULL)) 
				{
					cout << "Not a valid directory!\n";
					return 8;
				}
			}
			else
			{
				int i=0;
				while(info.cAlternateFileName[i]) working_dir[i]=info.cAlternateFileName[i];
			}
			if(hFile) FindClose(hFile);

			int line_number=0;
			while(!feof(list_file))
			{
				char line[270];
				char *file_path;
				char *crc_str;
				char *file_size_str;

				if(!fgets(line,270,list_file))
				{
					if(list_file) fclose(list_file);
					return 0;//end of file; there is nothing here; close;
				}

				crc_str=strtok(line, "|");
				file_size_str=strtok(NULL, "|");
				file_path=strtok(NULL, "|");
				
				if(strcmp(crc_str,"xxxxxxxx")&&strcmp(crc_str,"--------"))
				{
					cout << file_path;

					FILE *list_file2;
					list_file2=fopen(working_list,"r");
					if(!list_file2)
					{
						cout << "Not a valid file!\n";
						fclose(list_file);//close the org file
						return 5;
					}

					int check_line_number=0;
					bool first_file=true;

					while(!feof(list_file2))
					{
						char check_line[270];
						char *check_file_path;
						char *check_crc_str;
						char *check_file_size_str;
						
						char crc_number[17];
						char crc_file[MAX_PATH];

						for(int i=0; i<MAX_PATH; i++) crc_file[i]=working_dir[i];			

						if(!fgets(check_line,270,list_file2))//get full line in memory
						{
							break;//end of list; close
						}

						check_crc_str=strtok(check_line, "|");
						check_file_size_str=strtok(NULL, "|");
						check_file_path=strtok(NULL, "|");

						if(strcmp(check_crc_str,"xxxxxxxx")&&strcmp(check_crc_str,"--------"))
						{
							if(!strcmp(check_crc_str,crc_str)&&!strcmp(check_file_size_str,file_size_str))
							{
								FILE *file_copy;
								if(check_line_number>line_number)
								{
									//make file name from crc number
									int space_skipper=0;
									for(int crc_copy=0; crc_copy<strlen(check_crc_str); crc_copy++)
									{
										if(check_crc_str[crc_copy]!=' ')
										{
											crc_number[space_skipper]=check_crc_str[crc_copy];
											space_skipper++;
										}
									}

									for(int file_size_copy=0; file_size_copy<strlen(check_file_size_str); file_size_copy++)
									{
										if(check_file_size_str[file_size_copy]!=' ')
										{
											crc_number[space_skipper]=check_file_size_str[file_size_copy];
											space_skipper++;
										}
									}

									crc_number[space_skipper]='\0';

									strcat(crc_file,crc_number);
									strcat(crc_file,".txt");

									file_copy=fopen(crc_file,"a");

									if(file_copy)
									{
										if(first_file)
										{
											fwrite(file_path,1,strlen(file_path),file_copy);
											first_file=false;
										}
										fwrite(check_file_path,1,strlen(check_file_path),file_copy);
										fclose(file_copy);
									}
								}
								else if(check_line_number==line_number){}
								else break;
							}
						}
						check_line_number++;	
					}
					fclose(list_file2);
				}
				line_number++;//hidden little thing that counts the lines
			}
			fclose(list_file);
			return 0;
		}
	}

	cout << "Doopfinder v1.0: A duplicate file finder\nCopyright (c) 2011 Ben Shultz pipesc@comcast.com\n\n";

	cout << "This program comes with ABSOLUTELY NO WARRANTY;\nThis is free software, and you are welcome to\nredistribute it under certain conditions; type `doopfinder -w' for details.\n\n";

	cout << "Use -l to create a list of files to find.\nUse -f to find duplicate files in a created list.\n";
	cout << "doopfinder -l list.txt - c:\\dir\\    :Create a text file index.\n";
	cout << "doopfinder -f list.txt - c:\\found\\  :Search an index; save results in a folder.\n";
	cout << "View the README for more information.\n\n";
	
	return 1;
}
